import numpy as np

'''
Functions dealing with economic depreciation
'''


def calculate_pump_efficiency(Qfeed_m3day):
    """
    Calculate the pump efficiency based on feed flow rate [m3/day] to the pump.

    Reference: Kim, Jungbin; Hong, Seungkwan (2023):
    Pilot study of emerging low-energy seawater reverse osmosis desalination technologies for high-salinity, high-temperature, and high-turbidity seawater.
    In Desalination 565, p. 116871. DOI: 10.1016/j.desal.2023.116871.

    Parameters:
    Qfeed_m3day (float): Pump feed flow rate in m3/day.

    Returns:
    float: The pump efficiency [-].
    """

    if Qfeed_m3day > 13300:
        pump_efficiency = 1.3196 * np.log(Qfeed_m3day) + 73.05  # [%]
    else:
        pump_efficiency = 9.2234 * np.log(Qfeed_m3day) - 1.999  # [%]

    return pump_efficiency / 100  # [-]

def estimate_pump_cost(flow_rate_m3h, pressure_delta, tech_params, proj_params):
    """
    Estimate the cost of the high-pressure pump based on flow rate and pressure.

    Parameters:
    flow_rate_m3h (float): The feed flow rate in m³/h.
    pressure_delta (float): The required pressure difference (in bar) to be generated by the pump.
    tech_params (dict): Dictionary containing technical configuration and parameters.
    proj_params (dict): Dictionary containing project-specific configuration and parameters.

    Returns:
    float: Estimated pump cost in USD_current.
    """
    if flow_rate_m3h <= 450:
        return estimation_HPpump_cost_single(flow_rate_m3h, pressure_delta, tech_params, proj_params)
    else:
        return estimation_HPpump_cost_parallpumps(flow_rate_m3h, pressure_delta, tech_params, proj_params)
    

def estimation_HPpump_cost_single(Vfeed, pressure_delta, tech_config_and_params, proj_config_and_params):
    #if Vfeed == 450:
    #    pump_cost = tech_config_and_params['coeffA_catA_HPP'] + tech_config_and_params['coeffB_catA_HPP'] * Pfeed_1
    if 200 < Vfeed <= 450:
        #pump_cost = tech_config_and_params['coeffA_catB_HPP'] * np.power((Pfeed_1 * Vfeed), tech_config_and_params['coeffB_catB_HPP'])
        pump_cost = tech_config_and_params['coeffA_catB_HPP'] * (pressure_delta * Vfeed)**tech_config_and_params['coeffB_catB_HPP']
    else:  # Vfeed < 200
        pump_cost = tech_config_and_params['coeffA_catC_HPP'] * pressure_delta * Vfeed

    return pump_cost * proj_config_and_params['CEPCI']['current'] / proj_config_and_params['CEPCI']['1996']

def estimation_HPpump_cost_parallpumps(Vfeed, pressure_delta, tech_config_and_params, proj_config_and_params):
    Vfeed_1 = 450
    pump_cost_1 = tech_config_and_params['coeffA_catA_HPP'] + tech_config_and_params['coeffB_catA_HPP'] * pressure_delta
    Vfeed_2 = Vfeed - Vfeed_1
    if Vfeed_2 <= 450:
        pump_cost_2 = estimation_HPpump_cost_single(Vfeed_2, pressure_delta, tech_config_and_params, proj_config_and_params)
    else:
        pump_cost_2 = estimation_HPpump_cost_parallpumps(Vfeed_2, pressure_delta, tech_config_and_params, proj_config_and_params)
    pump_cost = pump_cost_1 + pump_cost_2
    return pump_cost * proj_config_and_params['CEPCI']['current'] / proj_config_and_params['CEPCI']['1996']